__author__ = 'Martin'

from lists.list import List

class ModList_(List):

    """
    A reduced increase in memory is required in a subclass of List but only for insertions
    Any increase due to pushing items is to remain unchanged
    """

    def _check_capacity(self):              # overrides List._check_capacity. inherited push() will call it so
        if self.SP < self.capacity - 1:
            return
        self.capacity = self.capacity + 2
        self._new_array()

    def push(self, item):                   # must be overridden to call the old _check_capacity
        super()._check_capacity()
        super().push(item)


lst = ModList_()
lst.push(1)
print(lst)
lst.insert_at(0, 0)
print(lst)
lst.insert_at(lst.size(), 2)
print(lst)
lst.push(4)
print(lst)
lst.insert_at(3, 3)
print(lst)